#include <string.h>
#include <iostream>
#include <fstream>
#include <stdlib.h>
using namespace std;

const int MAXN = 100;
const int MAXA = 5;
const int MAXI = 200;

enum Attivita {PESI, CORPO_LIBERO, PILATES, KARATE, SPINNING};

struct Iscritto {
  char nome[MAXN];
  char cognome[MAXN];
  float credito;
  Attivita att[MAXA];
  int numAtt;
};

struct Palestra {
  Iscritto iscr[MAXI];
  int numIscr;
};

bool nuovoIscritto(Palestra* pp, const char n[],  const char c[], float s);
bool aggiungiAttivita(Palestra* pp, const char n[], const char c[], Attivita a); 
bool salvaOrd(const Palestra* pp, const char filen[]);
void prelevaRata(Palestra* pp, Attivita a, float r);
bool elimina(Palestra* pp, const char n[], const char c[]);
int quantiRosso(const Palestra* pp);

void menu(){
  cout << "\n---------------------" << endl;
  cout << "1) nuovo iscritto" << endl;
  cout << "2) aggiungi attivita" << endl;
  cout << "3) salva ord." << endl;
  cout << "4) preleva rata" << endl;
  cout << "5) elimina" << endl;
  cout << "6) quanti rosso" << endl;
  cout << "7) esci" << endl; 
  cout << "Scelta? ";
}

Attivita leggiAttivita(){
  cout << "Quale attivita?" << endl;
  const char* strAtt[] = {"pesi", "corpo_libero", "pilates", "karate", "spinning"};
  for(int i=PESI; i<=SPINNING; i++) 
    cout << i << ") " << strAtt[i] << endl;
  int x;
  cin >> x;
  return (Attivita) x;
}

int main(){
  Palestra p;
  p.numIscr = 0;
  char c;
  int q;
  bool b;
  float r;
  Attivita a;
  char nome[MAXN];
  char cognome[MAXN];
  while(true) {
    menu();
    cin >> c;
    switch(c) {
      case '1':
        cout << "Inserisci nome: ";
        cin >> nome;
        cout << "Inserisci cognome: ";
        cin >> cognome;
        cout << "Inserisci credito iniziale: ";
        cin >> r;
        b = nuovoIscritto(&p, nome, cognome, r);
        if(b) cout << "Inserimento ok" << endl;
        else cout << "Non riesco ad inserire" << endl;
        break; 
      case '2':
        cout << "Inserisci nome: ";
        cin >> nome;
        cout << "Inserisci cognome: ";
        cin >> cognome;
        a = leggiAttivita();
        b = aggiungiAttivita(&p, nome, cognome, a);
        if(b) cout << "Attivita aggiunta" << endl;
        else cout << "Non riesco ad aggiungere l'attivita" << endl;
        break; 
      case '3':
        cout << "Provo a salvare nel file lista.txt" << endl;
        b = salvaOrd(&p, "lista.txt");
        if(b) {
          cout << "Salvataggio ok" << endl;
          cout << "Contenuto del file:" << endl;
          system("type lista.txt");
        } else cout << "Errore nel salvataggio" << endl;
        break;
      case '4':
        cout << "Inserisci importo rata: ";
        cin >> r;
        a = leggiAttivita();
        prelevaRata(&p, a, r);  
        break;      
      case '5':
        cout << "Inserisci nome: ";
        cin >> nome;
        cout << "Inserisci cognome: ";
        cin >> cognome;
        b = elimina(&p, nome, cognome);
        if(b) cout << "Eliminato" << endl;
        else  cout << "Non eliminato" << endl;   
        break;
      case '6':
        q = quantiRosso(&p);
        cout << "Ci sono " << q << " iscritti in rosso" << endl;
        break;
      case '7':
        return 0;
    }
  }
}
