#include <string.h>
#include <iostream>
#include <fstream>
using namespace std;

const int MAXN = 100;
const int MAXA = 5;
const int MAXI = 200;

enum Attivita {PESI, CORPO_LIBERO, PILATES, KARATE, SPINNING};

struct Iscritto {
  char nome[MAXN];
  char cognome[MAXN];
  float credito;
  Attivita att[MAXA];
  int numAtt;
};

struct Palestra {
  Iscritto iscr[MAXI];
  int numIscr;
};

bool nuovoIscritto(Palestra* pp, const char n[], const char c[], float s){
  if(pp->numIscr == MAXI) return false;
  strcpy(pp->iscr[pp->numIscr].nome, n);
  strcpy(pp->iscr[pp->numIscr].cognome, c);
  pp->iscr[pp->numIscr].credito = s;
  pp->numIscr++;
  return true;
}

bool aggiungiAttivita(Palestra* pp, const char n[], const char c[], Attivita a) {
  for(int i=0; i<pp->numIscr; i++)
    if(strcmp(pp->iscr[i].nome, n) == 0 && strcmp(pp->iscr[i].cognome, c) == 0 && pp->iscr[i].numAtt < MAXA) {
      pp->iscr[i].att[pp->iscr[i].numAtt] = a;
      pp->iscr[i].numAtt++;
      return true;
    }
  return false;
}

void ordina(Iscritto v[], int n) {
  for(int i=0; i<n-1; i++) {
    int index = i;
    for(int j=i+1; j<n; j++) 
      if(v[j].credito < v[index].credito)
        index = j;
    Iscritto tmp = v[i];
    v[i] = v[index];
    v[index] = tmp;
  }
}

bool salvaOrd(const Palestra* pp, const char filen[]) {
  Iscritto aux[MAXI];
  for(int i=0; i<pp->numIscr; i++)
    aux[i] = pp->iscr[i];
  ordina(aux, pp->numIscr);
  fstream ff;
  ff.open(filen, ios::out);
  if(!ff) return false;
  for(int i=0; i<pp->numIscr; i++)
    ff << aux[i].credito << ' ' << aux[i].nome << ' ' << aux[i].cognome << endl;
  return true;
}

void prelevaRata(Palestra* pp, Attivita a, float r) {
  for(int i=0; i<pp->numIscr; i++)
    for(int j=0; j<pp->iscr[i].numAtt; j++)
      if(pp->iscr[i].att[j] == a)
        pp->iscr[i].credito -= r;
}

bool elimina(Palestra* pp, const char n[], const char c[]) {
  for(int i=0; i<pp->numIscr; i++)
    if(strcmp(pp->iscr[i].nome, n) == 0 &&
       strcmp(pp->iscr[i].cognome, c) == 0) {
      pp->iscr[i] = pp->iscr[pp->numIscr-1];
      pp->numIscr--;
      return true;
    }
  return false;
}

int quantiRosso(const Palestra* pp) {
  int conta = 0;
  for(int i=0; i<pp->numIscr; i++)
    if(pp->iscr[i].credito < 0)
      conta++;
  return conta;
}

